package fehler;

public class Beispiel5 {

	/**
	 * Eigene Exceptions können erstellt werden, indem eine Klasse von
	 * "Exception" abgeleitet wird, und mit Hilfe des Schlüsselworts "throw" an
	 * der gewünschten Stelle "geworfen" wird.
	 * 
	 * Das Beispiel zeigt weiter, wie der finally-Block an einen try-catch-Block
	 * angehangen werden kann, um Code, der "in jedem Fall" ausgeführt werden
	 * soll, unterzubringen.
	 * 
	 */
	
	public static void main(String[] args) {
		
		try {
			macheIrgendwas();
		} catch (MyException1 e) {
			e.printStackTrace();
		} finally {
			aufraumen();
		}

	}

	private static void aufraumen() {
		System.out.println("Programm beendet.");
	}

	private static void macheIrgendwas() throws MyException1 {
		// Die statische Methode Math.random() gibt eine Zufallszahl
		// zwischen 0 und 1 zurück:
		double d = Math.random();
		if (d < 0.3) {
			// ok
			System.out.println("Der Wert für d(=" + d + ") < 0.3");
		} else {
			MyException1 ex = new MyException1("Der Wert von d(=" + d + ") > 0.3");
			throw ex;
		}
		System.out.println("MacheIrgendwas hat funktioniert");
	}

}
